/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c                                                */
/*  DATE        :                                                      */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
#include "iodefine.h"

#define MOTOR_PORTMODE PM1
#define MOTOR_PORT P1

#define ENABLE  1
#define DISABLE 0

#define LEFT_MOTOR  0
#define RIGHT_MOTOR 1
#define ALL_MOTOR   2

#define DIR_FORWARD  0
#define DIR_BACKWARD 1

#define STEP_MODE_S  0
#define STEP_MODE_Q  1
#define STEP_MODE_E  2
#define STEP_MODE_H  3

#define Motor_enable(x) (x==ENABLE)?(MOTOR_PORT|=0x80):(MOTOR_PORT&=0x7F)

void main(void);

void Initialize_Port(void)
{
  MOTOR_PORTMODE=0x00;                 // [^So
  MOTOR_PORT=0x00;                     // [^SLow
}

void Motor_1_step_walk(unsigned char motor,unsigned char direction)
{
  if(direction==DIR_FORWARD)           // 
  {
    if(motor==LEFT_MOTOR)              // [^?
    {
      MOTOR_PORT&=0xfd;                // DIR=0()
      MOTOR_PORT^=0x01;                // CLK]
    }
    else
    {
      MOTOR_PORT&=0xf7;                // EDIR=0()
      MOTOR_PORT^=0x04;                // ECLK]
    }
  }
  else
  {
    if(motor==LEFT_MOTOR)              // [^?
    {
      MOTOR_PORT|=0x02;                // DIR=1(t)
      MOTOR_PORT^=0x01;                // CLK]
    }
    else
    {
      MOTOR_PORT|=0x08;                // EDIR=1(t)
      MOTOR_PORT^=0x04;                // ECLK]
    }
  }
}
void Set_step_mode(unsigned char mode)
{
  unsigned char InputValue;
  InputValue=MOTOR_PORT;
  InputValue&=0xcf;
  if(mode==STEP_MODE_S)                // Xebv[hSixteenth?
  {
    InputValue|=0x00;
  }
  else if(mode==STEP_MODE_Q)           // Xebv[hQuarter?
  {
    InputValue|=0x10;
  }
  else if(mode==STEP_MODE_E)           // Xebv[hEighth?
  {
    InputValue|=0x20;
  }
  else if(mode==STEP_MODE_H)           // Xebv[hHalf?
  {
    InputValue|=0x30;
  }
  MOTOR_PORT=InputValue;               // Xebv[ho
}
void delay_ms(int ms)
{
  volatile int i,j;
  for(i=0;i<ms;i++)
  {
    for(j=0;j<2963;j++)
    {

    }
  }
}
void main(void)
{
  Initialize_Port();                   // |[g
  Set_step_mode(STEP_MODE_H);          // Xebv[hݒ
  Motor_enable(ENABLE);                // [^
  while(1)
  {
    Motor_1_step_walk(LEFT_MOTOR,DIR_FORWARD);    // [^PXebv 
    Motor_1_step_walk(RIGHT_MOTOR,DIR_FORWARD);   // [^PXebv E
    delay_ms(1);                       // 1ms wait
  }
}
