/***********************************************************************/
/*                                                                     */
/*  FILE        :hardware_setup.c                                      */
/*  DATE        :                                                      */
/*  DESCRIPTION :Hardware setup Program                                */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
#include "iodefine.h"
#include "macrodriver.h"

volatile unsigned char * gp_csi00_tx_address;  // csi00 send buffer address
volatile unsigned short  g_csi00_tx_count;     // csi00 send data count

void HardwareSetup(void);
void PortInit(void);
void CSI00Create(void);
void CSI00Start(void);
void CSI00Send(unsigned char *tx_buf,unsigned char tx_num);

void HardwareSetup(void)
{
  PortInit();                          // |[g
  CSI00Create();                       // CSI00
  EI();                                // 荞݋
} 
void PortInit(void)
{
  P1 = 0B01110000;                     // P14-6:High,P17:Low
  PM1 = 0B00001111;                    // P10-3:́AP14-7:o
  P14_bit.no6 = 0;                     // LED Ito
  PM14_bit.no6 = 0;
}
void CSI00Create(void)
{
  SAU0EN = 1;                          // VAACjbgNbN
  NOP();
  NOP();
  NOP();
  NOP();
  SPS0 = 0x0000;                       // 32MHzI

  SMR00 = 0x0020;                      // 32MHz,CSI[h,]荞
  SCR00 = 0x8007;                      // M̂,^Cv1,MSBt@[Xg,8rbgf[^
  SDR00 = 0x6400;                      // fMCX/102=313725Hz
  SO0 = 0x0100;                        // VANbNoHigh,f[^Low
  SOE0L_bit.no0 = 1;                   // VAʐM싖
  P1_bit.no2 = 1;
  PM1_bit.no2 = 0;                     // f[^Higho
  P1_bit.no0 = 1;
  PM1_bit.no0 = 0;                     // NbNHigho
}
void CSI00Start(void)
{
  SS0L_bit.no0 = 1;                    // Mҋ@Zbg
  CSIIF00 = 0;                         // CSI00荞ݗvNA
  CSIMK00 = 0;                         // CSI00荞݃}XNNA
}
void CSI00Send(unsigned char *tx_buf,unsigned char tx_num)
{
  g_csi00_tx_count = tx_num;           // MoCgRs[
  gp_csi00_tx_address = tx_buf;        // MAhXRs[
  CSIMK00 = 1;                         // CSI00荞݃}XNZbg
  SIO00 = *gp_csi00_tx_address;        // Mf[^ݒ
  gp_csi00_tx_address++;               // MAhXAbv
  g_csi00_tx_count--;                  // MoCgJEg_E
  CSIMK00 = 0;                         // CSI00}XNNA
}
