/***********************************************************************/
/*                                                                     */
/*  FILE        :interrupt_handlers.c                                  */
/*  DATE        :                                                      */
/*  DESCRIPTION :Interrupt Program                                     */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
#include "iodefine.h"
#include "macrodriver.h"

extern volatile uint8_t   g_iic00_master_status_flag; // iic00 start flag
extern volatile uint8_t * gp_iic00_tx_address;        // iic00 send data pointer
extern volatile uint16_t  g_iic00_tx_count;           // iic00 send data size
extern volatile uint8_t * gp_iic00_rx_address;        // iic00 receive data pointer
extern volatile uint16_t  g_iic00_rx_count;           // iic00 receive data size
extern volatile uint16_t  g_iic00_rx_length;          // iic00 receive data length
extern unsigned char iic_send_end;     // IICM
extern unsigned char iic_read_end;     // IICM

extern void IIC00_StopCondition(void);


#pragma interrupt INT_IIC00(vect=INTIIC00)
void INT_IIC00(void)
{
  if( ( (SSR00 & 0x0002) == 0)&&( (SSR00 & 0x0001) == 0 ) ) //ACKMI[oG[Ȃ?
  {
    // send
    if( g_iic00_master_status_flag & 0x01 )    // Xe[^X }X^M?
    {
      if( g_iic00_tx_count > 0 )
      {
        SIO00 = *gp_iic00_tx_address;  // Mf[^ݒ
        gp_iic00_tx_address++;         // Mf[^AhXAbv
        g_iic00_tx_count--;            // MoCgJEg_E
      } else
      {
        IIC00_StopCondition();         // XgbvRfBV
        iic_send_end = 1;              // MZbg
      }
    } else
    {
      if( (g_iic00_master_status_flag & 0x04) == 0x00 )  // Xe[^X AhXM?
      {
        ST0 |= 0x0001;                 // ʐM~
        SCR00 &= ~0xC000;              // MNA
        SCR00 |= 0x4000;               // M̂ݍs
        SS0 |= 0x0001;                 // ʐMҋ@Zbg
        g_iic00_master_status_flag |= 0x04;  // AhXMς݃Zbg
        if(g_iic00_rx_length == 1)
        {
          SOE0 &= ~0x0001;             // VAʐMo͒~
        }
        SIO00 = 0xFF;                  // _~[Mݒ
      } else
      {
        if( g_iic00_rx_count < g_iic00_rx_length )  // Mf[^?
        {
          *gp_iic00_rx_address = SIO00;  // Mf[^i[
          gp_iic00_rx_address++;       // Mf[^i[AhXAbv
          g_iic00_rx_count++;          // Mf[^Abv
          if(g_iic00_rx_count < g_iic00_rx_length - 1 )
          {
            SOE0 &= ~0x0001;           // VAʐMo͒~
            SIO00 = 0xFF;              // _~[Mݒ
          } else if( g_iic00_rx_count == g_iic00_rx_length )
          {
            IIC00_StopCondition();	   // XgbvRfBV
            iic_read_end = 1;          // MZbg
          } else
          {
            SIO00 = 0xFF;              // _~[Mݒ
          }
        }
      }
    }
  }
}
