/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c                                                */
/*  DATE        :                                                      */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
#include "iodefine.h"

#define HC595_PORT   P1
#define HC595_DDR    PM1

#define dataPin      0                 // Data pin (DS) pin location
#define latchPin     1                 // Latch pin location
#define clockPin     2                 // Shift Clock (SH_CP) pin location
#define enablePin    3                 // Output Enable pin location 

// Low level macros to change data lines
#define Data(m)      m? (HC595_PORT|=(1<<dataPin)):(HC595_PORT&=(~(1<<dataPin)))
#define Clock(m)     m? (HC595_PORT|=(1<<clockPin)):(HC595_PORT&=(~(1<<clockPin)))
#define Latch(m)     m? (HC595_PORT|=(1<<latchPin)):(HC595_PORT&=(~(1<<latchPin)))
#define Enable(m)    m? (HC595_PORT|=(1<<enablePin)):(HC595_PORT&=(~(1<<enablePin)))

void main(void);

// Initialize Port for HC595 chip
void Init(void)
{
   // Make the data, clock, latch as output
   HC595_DDR&=~((1<<dataPin)|(1<<clockPin)|(1<<latchPin)|(1<<enablePin));
}
// MSB First Output shift register 74HC595.
// bitOrder: 1  : MSB First
// bitOrder: 0  : LSB First
void Write(unsigned int data, unsigned int bitOrder)
{
  unsigned int i;  
  Data(0);
  Clock(0);
  if(bitOrder==1){                     // MSB first?
    for(i=0;i<8;i++)                   // MSB first
    {
      Clock(0);                        // NbNLow
      if(data & 0b10000000)            // f[^ High?
      {
        Data(1);                       // f[^Pݒ
      }
      else
      {
        Data(0);                       // f[^Oݒ
      }
      Clock(1);                        // NbNHigh
      Data(0);                         // f[^Low
      data=data<<1;                    // f[^Vtg
    }
    Clock(0);                          // NbNLow
  }
  else
  {
    for(i=0;i<8;i++)                   // LSB first
    {
      Clock(0);                        // NbNLow
      if(data & 0b00000001)            // f[^ High?
      {
        Data(1);                       // f[^Pݒ
      }
      else
      {
        Data(0);                       // f[^Oݒ
      }
      Clock(1);                        // NbNHigh
      Data(0);                         // f[^Low
      data=data>>1;                    // f[^EVtg
    }
    Clock(0);                          // NbNLow
  }
}
void delay_ms(int ms)
{
  volatile int i,j;
  for(i=0;i<ms;i++)
  {
    for(j=0;j<2963;j++)
    {

    }
  }
}
void main(void)
{
  unsigned int i;
  int DispData[8]={                   // \f[^e[u
    0b00000000,
    0b11111111,
    0b00001001,
    0b00011001,
    0b00101001,
    0b01001001,
    0b10000110,
    0b00000000,
  };
  int col_select[8]={                  // \Ie[u
    0x01,0x02,0x04,0x08,
    0x10,0x20,0x40,0x80
  };
  //Init HC595
  Init();                              // 
  while(1)
  {
    for(i=0;i<8;i++)
    {
      Enable(1);                       // HC595o͋֎~
      Latch(0);                        // b`Low
      Write(~col_select[i], 1);        // \If[^HC595ɏo
      Write(DispData[i], 1);           // \f[^HC595ɏo
      Latch(1);                        // b`High(o)
      Enable(0);                       // HC595o͋
      delay_ms(1);                     // ԑ҂
    }
  }
}
