/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c                                                */
/*  DATE        :                                                      */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
#include "iodefine.h"
#define MOTOR_PORTMODE PM1
#define MOTOR_PORT P1

#define DIR1_ON() (MOTOR_PORT|=0x02)
#define DIR1_OFF() (MOTOR_PORT&=0xFD)
#define ENABLE1_OFF() (MOTOR_PORT|=0x04)
#define ENABLE1_ON() (MOTOR_PORT&=0xFB)

#define DIR2_ON() (MOTOR_PORT|=0x20)
#define DIR2_OFF() (MOTOR_PORT&=~0x20)
#define ENABLE2_OFF() (MOTOR_PORT|=0x40)
#define ENABLE2_ON() (MOTOR_PORT&=~0x40)

#define  nMotorA_PWM  TDR07
#define  nMotorB_PWM  TDR03
void Initialize_port(void);
void delay_ms(int ms);
void P0_P7_Out(int data);
void motor_start(void);
void main(void);
extern void HardwareSetup(void);

void main(void)
{
  motor_start();                       // [^Jn
}

void motor_start(void)
{
  int Segment_Data[10]=
  {0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x27,0x7F,0x6F};
  int i;

  HardwareSetup();                     // n[hEFAݒ
  Initialize_port();                   // |[g
  TS0L=0B10011100;                     // ^C}02,03,04,07JEgJn

  ENABLE1_ON();                        // [^P
  ENABLE2_ON();                        // [^Q
  while (1U)
  {
    P0_P7_Out(0x40);                   // VZOo'|'
    nMotorA_PWM=0;                     // [^A PWMNA
    nMotorB_PWM=0;                     // [^B PWMNA
    DIR1_ON();                         // [^P
    DIR2_ON();                         // [^Q
    for(i=0;i<10;i++)
    {
      delay_ms(1000);                  // 1s wait
      nMotorA_PWM=(TDR04+1)*(i+1)/10;  // [^A PWM i擾
      nMotorB_PWM=(TDR02+1)*(i+1)/10;  // [^B PWM i擾
      P0_P7_Out(Segment_Data[i]);      // VZOo
    }
    delay_ms(1000);                    // 1s wait
    nMotorA_PWM=0;                     // [^A PWMNA
    nMotorB_PWM=0;                     // [^B PWMNA
    P0_P7_Out(0x40);                   // VZOo'|'
    DIR1_OFF();                        // [^Pt
    DIR2_OFF();                        // [^Qt
    for(i=0;i<10;i++)
    {
      delay_ms(1000);                  // 1s wait
      nMotorA_PWM=(TDR04+1)*(i+1)/10;  // [^A PWM i擾
      nMotorB_PWM=(TDR02+1)*(i+1)/10;  // [^B PWM i擾
      P0_P7_Out(Segment_Data[i]);      // VZOo
    }
    delay_ms(1000);                    // 1s wait
  }
}
void Initialize_port(void)
{
  MOTOR_PORTMODE=0x00;                 // [^S|[go͐ݒ
  MOTOR_PORT=0x00;                     // [^SLow
  PM7=0x00;                            // P7So
  PM0=0x00;                            // P0So
}
void delay_ms(int ms)
{
  volatile int i,j;
  for(i=0;i<ms;i++)
  {
    for(j=0;j<2963;j++)
    {

    }
  }
}
void P0_P7_Out(int data)
{
  P0=(data>>6);                        // P01.P02ݒ
  P7=(data);                           // P70-6ݒ
}
